<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AddStdModelLibs xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/transformation/commands/AddStdModelLibs.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.transformation.commands;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionException;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IAdaptable;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IProgressMonitor;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IStatus;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.Status;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.URI;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.resource.ResourceSet;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.transaction.TransactionalEditingDomain;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.workspace.AbstractEMFOperation;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.LibraryUtils;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PackageImport;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <em class="jxr_javadoccomment"> * This class adds "standard" model libraries for component-based development: the FCM profile, parts of the MARTE profile (allocation)</em>
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <em class="jxr_javadoccomment"> * and the associated package imports to your model.</em>
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/components/transformation/commands/AddStdModelLibs.html">AddStdModelLibs</a> <strong class="jxr_keyword">extends</strong> AbstractEMFOperation {
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/components/transformation/commands/AddStdModelLibs.html">AddStdModelLibs</a>(Package pkg, TransactionalEditingDomain domain) {
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  		<strong class="jxr_keyword">super</strong>(domain, CMD_LABEL);
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  		selectedPkg = pkg;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  		availableImportPackages = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  		importList = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  	}
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String CMD_LABEL = <span class="jxr_string">"Add Designer CORE libraries"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String DESIGNER_BASIC_TRAFOS_URI = <span class="jxr_string">"pathmap://DML_TRAFOS/trafos.uml"</span>; //$NON-NLS-1$
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String DESIGNER_MARTE_CALLS_URI = <span class="jxr_string">"pathmap://QML_MARTE/marte.uml"</span>; //$NON-NLS-1$
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<strong class="jxr_keyword">protected</strong> EList&lt;PackageImport&gt; importList;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	<strong class="jxr_keyword">protected</strong> EList&lt;PackageImport&gt; availableImportPackages;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  	<strong class="jxr_keyword">protected</strong> Package selectedPkg;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 * Check whether a package import is already done</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment">	 * @param selectedPkg</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment">	 * @param pi</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<strong class="jxr_keyword">boolean</strong> isAlreadyImported(Package selectedPkg, PackageImport pi) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		<strong class="jxr_keyword">for</strong> (PackageImport existingPI : selectedPkg.getPackageImports()) {
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  			<strong class="jxr_keyword">if</strong> ((existingPI.getImportedPackage() == <strong class="jxr_keyword">null</strong>) ||
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  					(pi.getImportedPackage() == <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  				<em class="jxr_comment">// import package are null (should not happen?!)</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  				<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  			}
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  			<strong class="jxr_keyword">if</strong> ((existingPI.getImportedPackage().getName() == <strong class="jxr_keyword">null</strong>) ||
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  					(pi.getImportedPackage().getName() == <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  				<em class="jxr_comment">// import package name not set (should not happen?!)</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  				<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (existingPI.getImportedPackage().getName().equals(pi.getImportedPackage().getName())) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  			}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		}
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  <em class="jxr_comment">	 * (non-Javadoc)</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  <em class="jxr_comment">	 *</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  <em class="jxr_comment">	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_comment">	 */</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">	 * Return a list of package-imports for standard Qompass model libraries</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 * @throws ExecutionException</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  	<strong class="jxr_keyword">public</strong> EList&lt;PackageImport&gt; getAvailableImportPackages() {
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		<strong class="jxr_keyword">if</strong> (availableImportPackages != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  			<strong class="jxr_keyword">return</strong> availableImportPackages;
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  		}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		<strong class="jxr_keyword">final</strong> ResourceSet resourceSet = selectedPkg.eResource().getResourceSet();
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		availableImportPackages = <strong class="jxr_keyword">new</strong> BasicEList&lt;PackageImport&gt;();
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		PackageImport pi = LibraryUtils.getModelLibraryImportFromURI(URI.createURI(DESIGNER_BASIC_TRAFOS_URI), resourceSet);
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		<strong class="jxr_keyword">if</strong> (pi != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  			availableImportPackages.add(pi);
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		}
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		pi = LibraryUtils.getModelLibraryImportFromURI(URI.createURI(DESIGNER_MARTE_CALLS_URI), resourceSet);
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<strong class="jxr_keyword">if</strong> (pi != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 			availableImportPackages.add(pi);
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		<strong class="jxr_keyword">return</strong> availableImportPackages;
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 	}
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> <em class="jxr_javadoccomment">	 * @return a list of package-imports that are already imported (within the selected pkg).</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 	<strong class="jxr_keyword">public</strong> EList&lt;PackageImport&gt; getAlreadyImportedPackages() {
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		EList&lt;PackageImport&gt; availablePackages = getAvailableImportPackages();
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		EList&lt;PackageImport&gt; selection = <strong class="jxr_keyword">new</strong> BasicEList&lt;PackageImport&gt;();
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		<strong class="jxr_keyword">for</strong> (PackageImport pi : availablePackages) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 			<strong class="jxr_keyword">if</strong> (isAlreadyImported(selectedPkg, pi)) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 				selection.add(pi);
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			}
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		<strong class="jxr_keyword">return</strong> selection;
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 	}
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 * Initialize import list. Must be called, before the command gets executed.</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> <em class="jxr_javadoccomment">	 * @param importList</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> <em class="jxr_javadoccomment">	 *            a list of package-imports that will be added to the selectedPkg when</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a> <em class="jxr_javadoccomment">	 *            the command gets executed.</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setImportList(EList&lt;PackageImport&gt; importList) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		<strong class="jxr_keyword">this</strong>.importList = importList;
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 	}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L135" href="#L135">135</a> <em class="jxr_javadoccomment">	 * Initialize import list. Must be called, before the command gets executed.</em>
<a class="jxr_linenumber" name="L136" href="#L136">136</a> <em class="jxr_javadoccomment">	 * Convenience method for dialogs that return an array.</em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> <em class="jxr_javadoccomment">	 * @param importArray</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> <em class="jxr_javadoccomment">	 *            an array of objects (which must contain package-imports) that will</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> <em class="jxr_javadoccomment">	 *            be added to the selectedPkg when the command gets executed.</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setImportList(Object importArray[]) {
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 		importList = <strong class="jxr_keyword">new</strong> BasicEList&lt;PackageImport&gt;();
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		<strong class="jxr_keyword">for</strong> (Object importPkg : importArray) {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 			<strong class="jxr_keyword">if</strong> (importPkg instanceof PackageImport) {
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 				importList.add((PackageImport) importPkg);
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 			}
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 		}
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 	}
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 	@Override
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 	<strong class="jxr_keyword">protected</strong> IStatus doExecute(IProgressMonitor monitor, IAdaptable info)
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 			<strong class="jxr_keyword">throws</strong> ExecutionException {
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		<strong class="jxr_keyword">for</strong> (PackageImport pi : importList) {
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 			<strong class="jxr_keyword">if</strong> (!isAlreadyImported(selectedPkg, pi)) {
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 				selectedPkg.getPackageImports().add(pi);
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			}
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		}
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		<strong class="jxr_keyword">return</strong> Status.OK_STATUS;
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 	}
<a class="jxr_linenumber" name="L162" href="#L162">162</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
